// 004 u_10_dll
// 10 dec 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_10_dll;

interface

uses  ShareMem,

  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Memo1: TMemo;
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel5: TPanel;
    Panel6: TPanel;
    Edit1: TEdit;
    Memo2: TMemo;
    loadlibrary_pchar_: TButton;
    static_import_pchar_: TButton;
    Splitter2: TSplitter;
    static_d2010_import_: TButton;
    static_import_string_: TButton;
    loadlibrary_string_: TButton;
    static_import_length_: TButton;
    static_import_global_ref_: TButton;
    static_import_pv_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure loadlibrary_pchar_Click(Sender: TObject);
    procedure static_import_pchar_Click(Sender: TObject);
    procedure loadlibrary_string_Click(Sender: TObject);
    procedure static_d2010_import_Click(Sender: TObject);
    procedure static_import_string_Click(Sender: TObject);
    procedure static_import_length_Click(Sender: TObject);
    procedure static_import_global_ref_Click(Sender: TObject);
    procedure static_import_pv_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses Character, u_display_unicode;

{$R *.dfm}

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure do_display(p_string: String);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_string);
          RichEdit1.Text:= RichEdit1.Text+ p_string;
          Memo2.Lines.Add(p_string);
          Edit1.Text:= Edit1.Text+ p_string;

          display(f_display_unicode_string(p_string));
          for l_index:= 1 to Length(p_string) do
            display(Format('%2d ', [l_index])+ p_string[l_index]);
        end; // with Form1
      end; // do_display

    procedure do_display_ansi_string(p_ansi_string: AnsiString);
      var l_index: Integer;
      begin
        with Form1 do
        begin
          ListBox1.Items.Add(p_ansi_string);
          RichEdit1.Text:= RichEdit1.Text+ p_ansi_string;
          Memo2.Lines.Add(p_ansi_string);
          Edit1.Text:= Edit1.Text+ p_ansi_string;

          display(f_display_ansi_string(p_ansi_string));
          for l_index:= 1 to Length(p_ansi_string) do
            display(Format('%2d %1x ', [l_index, Ord(p_ansi_string[l_index])])+ p_ansi_string[l_index]);
        end; // with Form1
      end; // do_display_ansi_string

    procedure TForm1.loadlibrary_pchar_Click(Sender: TObject);
      const // k_dll_name: AnsiString= 'd_d6_echo.dll'; // 'D_D6_ECHO.DLL';
            k_dll_name= 'd_d6_echo.dll'; // 'D_D6_ECHO.DLL';
            k_echo_function_name= 'f_d6_echo';
      type t_fn_d6_echo= function(p_string_z: pAnsiChar): pAnsiChar; Stdcall;
      var l_dll_file_name: WideString;
          l_dll_handle: THandle;
          l_dll_echo_function_handle: t_fn_d6_echo;
          l_ansi_sring: AnsiString;
          l_string, l_result: String;
          l_p_ansichar, l_p_ansichar_result: pAnsiChar;
      begin
        display('LoadLibrary');
        if not FileExists(k_dll_name)
          then display('*** '+ k_dll_name+ ' .DLL_file_not_found');

        l_dll_handle:= LoadLibrary(k_dll_name);
(*
        l_dll_file_name:= 'd_d6_echo.dll';
        l_dll_handle:= LoadLibrary(pWideChar(l_dll_file_name));
        l_dll_handle:= LoadLibrary('d_d6_echo.dll');
        l_dll_handle:= LoadLibrary('D_D6_ECHO.DLL');
        l_dll_handle:= LoadLibrary('D_D6_ECHO');
*)
        if l_dll_handle<> 0
          then begin
              try
                display('ok_handle');
                l_dll_echo_function_handle:= GetProcAddress(l_dll_handle, k_echo_function_name);
                if Assigned(l_dll_echo_function_handle)
                  then begin
                      display('ok_GetProcAddress');

(*
                      l_string:= 'abc';
                      // NO 1 char l_p_ansichar:= pAnsiChar(l_string);
                      l_p_ansichar:= @l_string[1];
                      display(String(l_p_ansichar));
                      l_p_ansichar_result:= l_dll_echo_function_handle(l_p_ansichar);
                      l_result:= l_p_ansichar_result;
                      display(IntToStr(Length(l_string)));
                      display(String(l_p_ansichar_result));
*)
                      l_ansi_sring:= 'abc';
                      l_p_ansichar:= @l_ansi_sring[1];
                      l_p_ansichar_result:= l_dll_echo_function_handle(l_p_ansichar);
                      l_result:= l_p_ansichar_result;
                      display(String(l_p_ansichar_result));

(*
                      // -- NO 1 char l_p_ansichar_result:= l_dll_echo_function_handle('abc');
                      l_result:= l_p_ansichar_result;
                      display(String(l_p_ansichar_result));
*)
                    end
                  else display('NOK_GetProcAddress');
              finally
                FreeLibrary(l_dll_handle);
              end;
          end
        else display('not_loaded '+ IntToHex(l_dll_handle, 4));
      end; // loadlibrary_Click

    function f_d6_echo(p_string_z: pAnsiChar): pAnsiChar; Stdcall; External 'd_d6_echo.dll';

    procedure TForm1.static_import_pchar_Click(Sender: TObject);
      var l_ansi_sring: AnsiString;
          l_string, l_result: String;
          l_p_ansichar, l_pt_result: pAnsiChar;
      begin
        display('static');
        display(f_d6_echo('abc'));

        l_ansi_sring:= 'abc';
        // NO incompatible l_p_ansichar:= pAnsiString(l_ansi_sring);
        l_p_ansichar:= @l_ansi_sring[1];
        l_pt_result:= f_d6_echo(l_p_ansichar);
        l_result:= String(l_pt_result);
        display(l_result);
      end; // static_import_Click

    // -- string param

    procedure TForm1.loadlibrary_string_Click(Sender: TObject);
      const k_dll_name= 'd_d6_echo.dll'; // 'D_D6_ECHO.DLL';
            k_echo_function_name= 'f_d6_string_echo';
      type t_fn_d6_string_echo= function(p_string: AnsiString): AnsiString; Stdcall;
      var l_dll_file_name: WideString;
          l_dll_handle: THandle;
          l_dll_string_echo_function_handle: t_fn_d6_string_echo;
          l_ansi_sring, l_ansi_result: AnsiString;
          l_result: String;
      begin
        if not FileExists(k_dll_name)
          then display('*** '+ k_dll_name+ ' .DLL_file_not_found');

        l_dll_handle:= LoadLibrary(k_dll_name);
        if l_dll_handle<> 0
          then begin
              try
                display('ok_handle');
                l_dll_string_echo_function_handle:= GetProcAddress(l_dll_handle, k_echo_function_name);
                if Assigned(l_dll_string_echo_function_handle)
                  then begin
                      display('ok_GetProcAddress');

                      l_ansi_sring:= 'abc';
                      // incompat l_ansi_result:= l_dll_string_echo_function_handle(@l_ansi_sring[1]);
                      // AV borlndmm l_ansi_result:= l_dll_string_echo_function_handle(l_ansi_sring);
                      l_ansi_result:= l_dll_string_echo_function_handle('abc');
                      display(IntToStr(Length(l_ansi_result)));
                      display(l_ansi_result);
                    end
                  else display('NOK_GetProcAddress');
              finally
                FreeLibrary(l_dll_handle);
              end;
          end
        else display('not_loaded '+ IntToHex(l_dll_handle, 4));
      end; // loadlibrary_string_Click

    function f_d6_string_echo(p_string: AnsiString): AnsiString; Stdcall; External 'd_d6_echo.dll';

    var g_result_ansi_string: AnsiString= '';

    procedure TForm1.static_import_string_Click(Sender: TObject);
      var l_ansi_sring: AnsiString;
          // l_string, l_result: String;
          // l_pt_ansichar, l_pt_result: pAnsiChar;
      begin
        // -- bombs display(f_d6_string_echo('abc'));

        l_ansi_sring:= 'abc';
        // -- bombs "opration de pointeurs incorrecte"
        // l_result:= f_d6_string_echo(l_ansi_sring);
        // -- bombs "av"
        g_result_ansi_string:= f_d6_string_echo(l_ansi_sring);
      end; // static_import_string_Click

    function f_d6_string_echo_global_ref(p_string: AnsiString): AnsiString; Stdcall; External 'd_d6_echo.dll';

    procedure TForm1.static_import_global_ref_Click(Sender: TObject);
      var l_ansi_sring, l_result_ansi_string: AnsiString;
      begin
        l_ansi_sring:= 'abc';
        l_result_ansi_string:= f_d6_string_echo_global_ref(l_ansi_sring);

        display('resu '+ l_result_ansi_string);
      end;

    procedure d6_string_echo_pv_var(p_string: AnsiString; var pv_string: AnsiString); Stdcall; External 'd_d6_echo.dll';

    procedure TForm1.static_import_pv_Click(Sender: TObject);
      var l_ansi_sring, l_result_ansi_string: AnsiString;
      begin
        l_ansi_sring:= 'abc';

(*
        d6_string_echo_pv_var(l_ansi_sring, l_result_ansi_string);
        display('result '+ l_result_ansi_string);
        Exit;
*)
        // SetLength(l_result_ansi_string, 2000);
        l_result_ansi_string:= 'AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA';
        d6_string_echo_pv_var(l_ansi_sring, l_result_ansi_string);
        display('result '+ l_result_ansi_string);
        display('');
      end; // static_import_pv_Click

    function f_d6_string_echo_length(p_ansi_string: AnsiString): Integer; Stdcall; External 'd_d6_echo.dll';

    procedure TForm1.static_import_length_Click(Sender: TObject);
      begin
        display(IntToStr(f_d6_string_echo_length('abc')));
      end;

    // -- d2010 dll

    function f_d2010_ansistring_echo(p_ansi_string: AnsiString): AnsiString; Stdcall; External 'd_d2010_echo.dll';

    procedure TForm1.static_d2010_import_Click(Sender: TObject);
      begin
        display(f_d2010_ansistring_echo('abc'));
      end; // convert_cyrillic_Click

    end.



