// 003 u_display_unicode
// 21 nov 2010

// -- (C) John COLIBRI 2010
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_display_unicode;
  interface
    Uses Classes;

    const k_new_line= #13#10;
    type t_byte_array= Array[0..0] of Byte;
         t_pt_byte_array= ^t_byte_array;

         t_word_array= Array[0..0] of Word;
         t_pt_word_array= ^t_word_array;

         t_new_string_header=
             packed record
               m_code_page: Word;
               m_element_size: Word;
               m_reference_count: Longint;
               m_element_count: Longint;
               m_bytes: t_byte_array;
             end;
         t_pt_new_string_header= ^t_new_string_header;

    function f_display_unicode_string(var pv_unicode_string: String): String;
    function f_display_ansi_string(var pv_ansi_string: AnsiString): String;
    function f_utf_16_at(var pv_unicode_string: String; p_index: Integer): Word;

    function f_byte_array_to_hex(var pv_byte_array: t_byte_array;
                 p_count: Integer): String;
    function f_stream_hex_dump(p_c_stream: tStream): String;
    function f_file_hex_dump(p_file_name: String): String;

  implementation
    uses SysUtils
        ;

    function f_byte_array_to_hex(var pv_byte_array: t_byte_array; p_count: Integer): String;
      var l_index: integer;
      begin
        Result:= '';
        for l_index := 0 to p_count- 1 do
          (*$r-*)
          Result:= Result + Format('%1x ', [pv_byte_array[l_index]]);
          (*$r+*)
      end; // f_byte_array_to_hex

    function f_display_unicode_string(var pv_unicode_string: String): String;
      begin
        with t_pt_new_string_header(Integer(pv_unicode_string)- 12)^ do
        begin
          Result:= '  string :    >'+ pv_unicode_string+ '< Length: '
                  + IntToStr(Length(pv_unicode_string))+ k_new_line
              + Format('  code page     %d', [m_code_page])+ k_new_line
              + Format('  element size  %d', [m_element_size]) + k_new_line
              + Format('  ref_count     %d', [m_reference_count]) + k_new_line
              + Format('  element count %d', [m_element_count]) + k_new_line
              + Format('  byte  count   %d', [m_element_count* m_element_size]) + k_new_line
              + '  bytes $       '+ f_byte_array_to_hex(m_bytes,
                  m_element_count* m_element_size)
        end; // with t_pt_new_string_header^
      end; // f_display_unicode_string

    function f_display_ansi_string(var pv_ansi_string: AnsiString): String;
      begin
        with t_pt_new_string_header(Integer(pv_ansi_string)- 12)^ do
        begin
          Result:= '  string :    >'+ pv_ansi_string+ '<Length: '
                  + IntToStr(Length(pv_ansi_string))+ k_new_line
              + Format('  code page     %d', [m_code_page])+ k_new_line
              + Format('  element size  %d', [m_element_size]) + k_new_line
              + Format('  ref_count     %d', [m_reference_count]) + k_new_line
              + Format('  element count %d', [m_element_count]) + k_new_line
              + Format('  byte  count   %d', [m_element_count* m_element_size]) + k_new_line
              + '  bytes         $'+ f_byte_array_to_hex(m_bytes,
                  m_element_count* m_element_size)
        end; // with t_pt_new_string_header^
      end; // f_display_ansi_string

    function f_utf_16_at(var pv_unicode_string: String; p_index: Integer): Word;
        // -- the word at the "string index" nnn
      begin
        (*$r-*)
        Result:= t_pt_word_array(Integer(pv_unicode_string))^[p_index- 1];
        (*$r+*)
      end; // f_utf_16_at

    function f_stream_hex_dump(p_c_stream: tStream): String;
      var l_index: integer;
          l_byte: Byte;
      begin
        Result:= '';
        p_c_stream.Position:= 0;
        for l_index:= 0 to p_c_stream.Size- 1 do
        begin
          p_c_stream.Read(l_byte, 1);
          Result:= Result + Format('%1x ', [l_byte]);
        end; // for l_index
      end; // f_byte_array_to_hex

    function f_file_hex_dump(p_file_name: String): String;
      var l_c_file_stream: tFileStream;
      begin
        l_c_file_stream:= tFileStream.Create(p_file_name, fmOpenRead);
        Result:= f_stream_hex_dump(l_c_file_stream);
        l_c_file_stream.Free;
      end; // f_file_hex_dump

    begin // u_zzz
    end. // u_zzz

